#version 150

#moj_import <minecraft:fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec4 vertexShading;
in vec4 lightMapColor;
in vec4 overlayColor;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    if (color.a < 0.01) {
        discard;
    }
	
#ifdef ELDER_GUARDIAN_FIX
	if (color.a > 0.101 && color.a < 0.105) {
		color.a = 1.0;
		color *= (1/vertexShading) * (1/lightMapColor);
	}
#endif
	
#ifndef NO_OVERLAY
    color.rgb = mix(overlayColor.rgb, color.rgb, overlayColor.a);
#endif

#ifndef NO_CARDINAL_LIGHTING
	if (!(color.a > 0.98 && color.a < 0.99)) {
		color *= vertexShading * lightMapColor;
	}
#endif
	
    fragColor = linear_fog(color * vertexColor * ColorModulator, vertexDistance, FogStart, FogEnd, FogColor);
}
